%global debug_package %{nil}

%if 0%{?fedora} <= 22 || (0%{?rhel} != 0 && 0%{?rhel} <= 7)
%global pypkg python
%global pysitelib %{python_sitelib}
%global __python %{__python2}
%if 0%{?fedora}
%global pylint pylint
%endif
%else
%global pypkg python3
%global pysitelib %{python3_sitelib}
%global __python %{__python3}
%global pylint python3-pylint
%endif

%global commit0 0705b1bde7d308988263cd5ef1106ce2901a7e00
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

# Registries package
%global git_atomic_registries https://github.com/projectatomic/registries
%global commit_atomic_registries 0b260d3eff505bc1ab60842a34cf9f31857658f4
%global atomic_registries_shortcommit %(c=%{commit_atomic_registries}; echo ${c:0:7})


Name: atomic
Epoch: 1
Version: 1.18.1
Release: 3.1.git%{shortcommit0}%{?dist}
Summary: Tool for managing ProjectAtomic systems and containers
License: LGPLv2+
URL: https://github.com/projectatomic/%{name}
Source0: https://github.com/projectatomic/%{name}/archive/%{commit0}.tar.gz
Source1: https://github.com/projectatomic/registries/archive/%{commit_atomic_registries}.tar.gz

BuildRequires: %{pypkg}-dateutil
BuildRequires: %{pypkg}-devel
BuildRequires: %{pypkg}-requests >= 2.4.3
BuildRequires: %{pypkg}-setuptools
BuildRequires: %{pypkg}-tools
BuildRequires: %{pypkg}-ipaddress
BuildRequires: %{pypkg}-dbus
BuildRequires: %{pypkg}-docker-py >= 1.7.2-1
BuildRequires: %{pypkg}-setuptools
BuildRequires: policycoreutils-%{pypkg}
BuildRequires: git
BuildRequires: go-md2man
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang} >= 1.7.4
BuildRequires: rpm-%{pypkg}
BuildRequires: PyYAML
BuildRequires: ostree-devel

Requires: dbus
Requires: polkit
Requires: setup
Requires: rpm-%{pypkg}
Requires: %{pypkg}-dateutil
Requires: %{pypkg}-dbus
Requires: %{pypkg}-docker-py >= 1.7.2-1
Requires: %{pypkg}-ipaddress
Requires: %{pypkg}-requests
Requires: %{pypkg}-setuptools
Requires: %{pypkg}-six >= 1.3.0
Requires: %{pypkg}-slip-dbus
Requires: %{pypkg}-websocket-client >= 0.11.0
Requires: skopeo >= 1:0.1.17-1
Requires: skopeo-containers >= 1:0.1.17-1
Requires: PyYAML
Requires: gomtree
Requires: ostree
Requires: runc
Requires: container-storage-setup

%description
The goal of Atomic is to provide a high level, coherent entrypoint to the
system, and fill in gaps.

atomic can make it easier to interact with container runtimes for different
kinds of containers, such as super-privileged and system containers.

The atomic host subcommand wraps rpm-ostree providing unified management.

# Atomic Registries
%package registries
Summary: Parses a global YAML registry file
Requires: glib2
Requires: libyaml
Requires: json-glib
BuildRequires: libyaml-devel
BuildRequires: json-glib-devel
BuildRequires: glib2-devel
BuildRequires: autoconf
BuildRequires: automake

%description registries
Utility that parses a global YAML registry file for container runtimes.


%prep
%setup -qn %{name}-%{commit0}
cd ../
tar zxf %{SOURCE1}

%build
cd ..
pushd registries-%{commit_atomic_registries}
sh ./autogen.sh
%configure
%make_build
popd
pushd atomic-%{commit0}
if [ %{pypkg} == 'python3' ]; then
    sed -i 's/input = raw_input/pass/' Atomic/util.py
fi
make PYTHON=%{__python} PYLINT=true all
popd

%install
make PYTHON=%{__python} install-only DESTDIR=%{buildroot}

%if 0%{?rhel}
make install-openscap DESTDIR=%{buildroot}
%endif

# Better support for doing continuous delivery by supporting optional
# components.  The canonical copy of this is in `rpm-ostree.spec`.
cat > autofiles.py <<EOF
#!%{pypkg}
import os,sys,glob
os.chdir(os.environ['RPM_BUILD_ROOT'])
for line in sys.argv[1:]:
    if line == '':
        break
    assert line[0] == '/'
    files = glob.glob(line[1:])
    if len(files) > 0:
        sys.stderr.write('{0} matched {1} files\n'.format(line, len(files)))
        sys.stdout.write(line + '\n')
    else:
        sys.stderr.write('{0} did not match any files\n'.format(line))
EOF
%{pypkg} autofiles.py > atomic.files \
  '%{pysitelib}/Atomic' \
  '%{pysitelib}/%{name}*.egg-info' \
  '%{_sysconfdir}/profile.d/%{name}.sh' \
  '%{_bindir}/%{name}' \
  '%{_datadir}/%{name}' \
  '%{_libexecdir}/%{name}/' \
  '%{_datadir}/bash-completion/completions/%{name}' \
  '%{_datadir}/dbus-1/system-services/org.%{name}.service' \
  '%{_datadir}/polkit-1/actions/org.%{name}.policy' \
  '%{_mandir}/man1/%{name}*'

#moved to skopeo - should not be present in future tarballs
rm -rf %{buildroot}%{_sysconfdir}/containers

cd ..
pushd registries-%{commit_atomic_registries}
%make_install
install -d %{buildroot}%{_sysconfdir}/containers/

#%if 0%{?rhel}
#install -p -m 644 registries.redhat %{buildroot}%{_sysconfdir}/containers/registries.conf
#%else
#%if  0%{?fedora}
#  install -p -m 644 registries.fedora %{buildroot}%{_sysconfdir}/containers/registries.conf
#%else
  install -p -m 644 registries.conf %{buildroot}%{_sysconfdir}/containers/
#%endif
#%endif

install -d %{buildroot}%{_unitdir}
install -p -m 644  registries.service %{buildroot}%{_unitdir}
popd

%check
[ ! -w /run/docker.sock ] || make PYTHON=%{__python} test
cd ..
pushd registries-%{commit_atomic_registries}
make check

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files -f atomic.files
%license COPYING
%doc README.md
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/org.%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}.d/openscap
%dir %{_sysconfdir}/%{name}.d

%files registries
%license ../registries-%{commit_atomic_registries}/COPYING 
%doc ../registries-%{commit_atomic_registries}/README.md
%{_libexecdir}/registries
%{_mandir}/man1/registries*
%config(noreplace) %{_sysconfdir}/containers/registries.conf
%{_unitdir}/registries.service

%changelog
* Thu Jun 22 2017 bbaude <bbaude@redhat.com> - 1:1.18.1-3.1.git0705b1b
- Fix conditional distro logic for registires.conf
- Fixes Bugzilla #1464029

* Mon Jun 05 2017 bbaude <bbaude@redhat.com> - 1:1.18.1-2.1.git0705b1b
- Rework spec file so that %setup can be used with multi-source packages
- Customized registries.conf file based on distro
- Updated autoconf to make distro support easier
- Run make check for atomic-registries

* Thu Jun 2 2017 bbaude <bbaude@redhat.com> - 1.18.1
- 1.18.1 release
- Inclusion of the subpackage for registries

* Thu Jun 01 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.17.2-6.1.git2760e30
- Resolves; #1457540 - require c-s-s at install time

* Mon May 22 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.17.2-5.1.git2760e30
- Add patch to resolve BZ # 1454292 (originally fixed in extras 7.3.5)
- bump release tag to stay ahead of extras 7.3

* Fri May 05 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.17.2-1.1.git2760e30
- rebase to 1.17.2
- built commit 2760e30
- require runc at install time for system containers

* Fri May 05 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.17.1-1.1.gitf304570
- bump to v1.17.1
- built commit f304570

* Mon Mar 27 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1.16.5-1.1
- rebuilt for all arches on extras 7.4
- enable debuginfo

* Tue Mar 21 2017 Dan Walsh <dwalsh@redhat.com> - 1.16.5-1
- bump to v1.16.5
-  Fix outdated container image message (BZ 1434430)
-  syscontainers: do not delete previous deployment on update
-  Atomic/mount.py: Allow different binary paths
-  Fix email address

* Fri Mar 17 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.16.4-2
- built @projectatomic/master commit 5e5800e

* Wed Feb 15 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.15.4-2
- built commit a21f0bc + re module bug patch

* Wed Feb 15 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.15.4-1
- Resolves: #1420532
- bump to v1.15.4
- built commit d56dcfb

* Mon Feb 13 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.15.3-1
- Resolves: #1421918
- bump to v1.15.3
- built commit a21f0bc

* Tue Feb 07 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.15.2-4
- built commit 2ebeb1d

* Tue Jan 31 2017 Dan Walsh <dwalsh@redhat.com> - 1.15.2-3
- Remove requires docker.

* Tue Jan 31 2017 Frantisek Kluknavsky <fkluknav@redhat.com> - 1:1.15.2-2
- v1.15.2 tag changed upstream, rebase

* Mon Jan 23 2017 Frantisek Kluknavsky <fkluknav@redhat.com> - 1:1.15.2-1
- rebase to v1.15.2

* Tue Jan 03 2017 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.14.1-5
- revert python-docker-py version requirement to what existed prior
to enforcing >= 1.10.6

* Sat Dec 24 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.14.1-4
- do not enforce version requirement on python-docker-py

* Thu Dec 22 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.14.1-3
- update runtime deps

* Sat Dec 17 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.14.1-2
- Requires: python-slip-dbus

* Wed Dec 14 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.14.1-1
- Resolves: #1404317 - rebase to v1.14.1
- built commit b182dbd

* Wed Nov 30 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.8-2
- Requires gomtree

* Mon Nov 07 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.8-1
- bump to v1.13.8
- built commit 8046db2

* Thu Nov 03 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.7-2
- built commit 4c3ea60

* Thu Nov 03 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.7-1
- Resolves: #1377952
- bump to v1.13.7
- built commit 1d01980

* Tue Nov 01 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.6-1
- bump to v1.13.6
- built commit a45a2a9

* Mon Oct 31 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.5-1
- bump to v1.13.5
- built commit 3d9567b

* Sat Oct 29 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.4-1
- bump to v1.13.4
- built commit 0331180

* Thu Oct 27 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.3-1
- bump to v1.13.3
- built commit 5a075e8

* Tue Oct 18 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.1-3
- needs skopeo >= 0.1.17-0.4

* Tue Oct 18 2016 Frantisek Kluknavsky <fkluknav@redhat.com> - 1:1.13.1-2
- do not package /etc/containers - moved to skopeo

* Tue Oct 11 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.1-1
- bump to v1.13.1
- built commit 4445c41 - tag v1.13.1

* Mon Oct 10 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.13.0-1
- Resolves: #1383452 - rebase to v1.13.0
- built commit 71d0ccb

* Mon Sep 26 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.5-2
- install /var/lib/atomic/sigstore

* Mon Sep 26 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.5-1
- built commit b807043

* Tue Sep 20 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.3-2
- built commit d551996

* Tue Sep 20 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.3-1
- bump to v1.12.3
- built commit bc0141b

* Tue Sep 20 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.2-3
- Resolves: #1376600
- built commit 4729fc0
- include default.yaml file for for OOTB signing experience.

* Fri Sep 16 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.2-2
- update changelog with bz#'s fixed in previous build

* Fri Sep 16 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.2-1
- bump to v1.12.2
- Resolves: #1375891 #1366937 #1353626 #1366255 #1347037 #1343948
- Resolves: #1342060 #1361949 #1350712 #1368566 #1342047 #1346921
- Resolves: #1346930 #1327529 #1346929 #1345820

* Tue Sep 13 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.1-3
- Resolves: #1374676 - only check setvalues argument when OSTREE_PRESENT

* Tue Sep 13 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.1-2
- Resolves: #1375578

* Tue Sep 13 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.1-1
- rebase to v.1.12.1

* Tue Sep 06 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.12.0-1
- Resolves: #1373977 - rebase to v1.12.0

* Tue Jul 12 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.5-7
- use skopeo >= 1:0.1.13-7

* Tue Jul 12 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.5-6
- skopeo is an independent package
- use autosetup
- dockertar-sha256-helper needs golang

* Wed Jun 15 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.5-5
- Resolves: #1343939 - fix image naming error
- Resolves: #1346942 - don't depend on ostree if it's not available

* Wed Jun 15 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.5-4
- own /etc/atomic.d

* Wed Jun 08 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.5-3
- bump release tag so that skopeo has something newer than 0.1.13-2

* Wed Jun 08 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.5-1
- bump to v1.10.5
- Resolves: #1300187, #1317798, #1323165, #1314541, #1311544, #1307034,
#1315369, #1331429, #1341922, #1341916

* Mon Jun 06 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.3-2
- Resolves: #1341916 - PyYAML is a runtime dep too
- install-openscap on rhel only, From Brent Baude <bbaude@redhat.com>

* Wed Jun 01 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.3-1
- bump atomic to v1.10.3, skopeo to v0.1.13

* Tue May 31 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.2-4.git02fe5ce
- use skopeo_version macro correctly

* Tue May 31 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1:1.10.2-3.git02fe5ce
- skopeo subpackage has its own version
- bump epoch so that skopeo's version can take effect

* Tue May 31 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1.10.2-2.git02fe5ce
- no dependency on OSTree if not available

* Tue May 31 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1.10.2-1.gitfdbe345
- Resolves: #1341174 - bump to v1.10.2
- BR: PyYAML

* Tue May 31 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1.10.1-1.gitee5d95e
- Resolves: #1341174 - rebase to 1.10.1
- rebase skopeo to v0.1.13

* Tue Mar 08 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1.9-4.gitff44c6a
- depend on python-docker-py >= 1.7.2-1

* Tue Mar 08 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1.9-3.gitff44c6a
- include skopeo subpackage

* Tue Mar 08 2016 Lokesh Mandvekar <lsm5@redhat.com> - 1.9-2.gitff44c6a
- Resolves: rhbz#1315846 - rebase to 1.9
- built atomic commit#ff44c6a

* Thu Feb 18 2016 Antonio Murdaca <runcom@fedoraproject.org> - 1.8-7.git1bc3814
- rebuilt

* Tue Jan 26 2016 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.8-6.git1bc3814
- built atomic commit#1bc3814

* Tue Jan 26 2016 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.8-5.git1bc3814
- Resolves: rhbz#1300459 - no .egg-info file/dir installed anymore
- built atomic commit#1bc3814

* Tue Jan 19 2016 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.8-4.git958d939
- Resolves: rhbz#1292776
- built atomic commit#958d939

* Tue Jan 19 2016 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.8-3.git958d939
- built atomic commit#958d939

* Tue Jan 05 2016 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.8-2.gita35ae18
- built atomic commit#a35ae18

* Tue Dec 01 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.7-3.git95b28a9
- Resolves: rhbz#1285461 - improved 'atomic images' formatting
- built atomic commit#95b28a9

* Mon Nov 23 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.7-2.git68be076
- built atomic commit#68be076

* Wed Nov 04 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.6-6.gitca1e384
- update python-docker-py dependency over what was shipped in 7.1.6 and 7.2.0

* Wed Nov 04 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.6-5.gitea18c14
- correct bogus date annoyance

* Wed Nov 04 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.6-4.gitea18c14
- Resolves: rhbz#1278145 - depend on python-docker-py >= 1.4.0-118

* Tue Nov 03 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.6-3.gitea18c14
- Resolves: rhbz#1272037
- built atomic commit#ea18c14

* Thu Oct 29 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.6-2.git50d7fd9
- built atomic commit#50d7fd9

* Thu Oct 22 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.6-1.gitca1e384
- built atomic commit#ca1e384
- Resolves: rhbz#1273365

* Fri Oct 09 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.5-4.git7e4365f
- built atomic @origin/master commit#7e4365f
- re-include python-setuptools at build and runtime

* Tue Oct 06 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.5-3.git82f4324
- Resolves: rhbz#1268926
- no dependency on python-setuptools
- depends on python-dbus at buildtime
- built atomic @origin/master commit#82f4324

* Wed Sep 30 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.5-2.git191fb53
- Resolves: rhbz#1265974 (extras-rhel-7.1.6) - include atomic
- Resolves: rhbz#1211359 (extras-rhel-7.2) - include atomic
- built atomic @origin/master commit#191fb53

* Wed Sep 23 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.4-3.git9d724aa
- ping version req for python-docker-py

* Mon Sep 14 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.4-2.git9d724aa
- unpin python-requests version requirement

* Mon Sep 14 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.4-1.git9d724aa
- built master commit#9d724aa
- scan subcommand added
- br: python-requests >= 2.4.3

* Mon Aug 03 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.1-1.git5f631c8
- bump to 1.1
- buildrequires policycoreutils-python(3)

* Fri Jul 24 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 1.0-1.git52d695c
- version 1.0 as per setup.py
- use latest upstream master commit
- run test only if docker.sock writable

* Tue Jul 14 2015 Miro Hrončok <mhroncok@redhat.com> - 0-0.12.gitfea1b99
- update to latest upstream master
- add new %%files and require dbus, polkit and setup to have the directories
- switch to Python 3
- disable build for arm (missing docker)
- Resolves: rhbz#1241947

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.11.gite5734c4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Apr 15 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.10.gite5734c4
- update to latest upstream master

* Tue Mar 03 2015 Colin Walters <walters@redhat.com> - 0-0.9.gita7ff4cb
- Match ExclusiveArch with docker (there is no docker on i686)

* Mon Mar 02 2015 Colin Walters <walters@redhat.com> - 0-0.8.gita7ff4cb
- Drop ExclusiveArch, we are just a wrapper for Docker, which in any
  case builds on other architectures now.

* Tue Feb 24 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.7.gita7ff4cb
- remove pylint for rhel/centos

* Tue Feb 24 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.6.gita7ff4cb
- runtime requirement: python-docker-py

* Tue Feb 24 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.5.gita7ff4cb
- build commit#a7ff4cb


* Thu Feb 19 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.3.gite4081c9
- manpage installation rules upstreamed

* Wed Feb 18 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.2.git6b82cb7
- install docs

* Wed Feb 18 2015 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.1.git6b82cb7
- Initial package
